Public Class Person
    Public Name As String

    ' This person's preferences.
    Public Preferences() As Integer

    ' This person's assignment.
    Public Assignment As Integer

    ' Return a string representing the Person's assignment.
    Public Function AssignmentString() As String
        Return Name & " (" & Value() & ")"
    End Function

    ' Initialize the Person from a string containing a name and preferences.
    Public Sub New(ByVal txt As String)
        Dim values() As String

        values = Split(txt, " ")
        Name = values(0)
        ReDim Preferences(NUM_PREFERENCES - 1)
        For i As Integer = 0 To NUM_PREFERENCES - 1
            Preferences(i) = CInt(values(i + 1))
        Next i

        Assignment = -1
    End Sub

    ' Return this Person's assignment value.
    Public Function Value() As Integer
        If Assignment < 0 Then
            Return NO_ASSIGNMENT
        Else
            Return ValueOf(Assignment)
        End If
    End Function

    ' Return this person's value for the choice.
    ' Return DONT_WANT if the person did not list this choice.
    Public Function ValueOf(ByVal choice As Integer) As Integer
        For i As Integer = 0 To NUM_PREFERENCES - 1
            If Preferences(i) = choice Then
                Return i
            End If
        Next i

        Return DONT_WANT
    End Function
End Class
